function varargout = GUI(varargin)
% GUI MATLAB code for GUI.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GUI

% Last Modified by GUIDE v2.5 09-Jan-2016 13:25:37

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before GUI is made visible.
function GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to GUI (see VARARGIN)

% Choose default command line output for GUI
handles.output = hObject;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% BEGIN CUSTOM VARIABLE INITIALISATION %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

handles.row = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% END OF CUSTOM VARIABLE INITIALISATION %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Begin custom code

function housesTable_CreateFcn(hObject, eventdata, handles)

    set(hObject, 'Data', cell(0));
    

function housesTable_CellSelectionCallback(hObject, eventdata, handles)

    % Abort if selection was removed due to insertion of new row
    if (numel(eventdata.Indices) == 0); return; end

    handles.row = eventdata.Indices(1);
    guidata(hObject, handles);
    

function buttonAddHouse_Callback(hObject, eventdata, handles)
    
    data = get(handles.housesTable,'Data');
    k = size(data,1)+1; % Set new row number

    if k == 1 % Convert data if table was empty beforehand
        newData = num2cell(data);    %guidata(hObject, handles);

    else
        newData = data;
    end

    newData{k,1} = '30';
    newData{k,2} = '3500';
    newData{k,3} = '05-2014';

    set(handles.housesTable,'Data',newData)
    guidata(hObject, handles);


function buttonDeleteHouse_Callback(hObject, eventdata, handles)

    k = handles.row;

    % If there's no more rows left or nothing's selecetd, abort
    if (k == 0); return; end

    % Delete selected row from the data set
    data = handles.housesTable.get('Data');
    data(k,:) = [];
    handles.housesTable.set('Data', data);

    % Make sure we don't delete anything until we select another row next
    handles.row = 0;
    
    guidata(hObject, handles);
    

function buttonDisplayOutputGui_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
neighbourhood_out    
    
function buttonStartSimulation_Callback(hObject, eventdata, handles)
    
    sys = System('simulation');
    % function setup(obj, houses, bcKWH, bs, otc, cuKWH, ccuKWH, bid, spe, bfbKWH, cbKWH, sd)
    sys.setup(handles.housesTable.get('Data'), ...
              handles.batteryCostPerKwh.get('String'), ...
              handles.batterySize.get('String'), ...
              handles.oneTimeCost.get('String'), ...
              handles.costPerKwhFromUtility.get('String'), ...
              handles.annualChangeOfCostPerKwhFromUtility.get('String'), ...
              handles.batteryInstallDate.get('String'), ...
              handles.solarPanelEfficiency.get('String'), ...
              handles.costPerKwhBoughtFromBattery.get('String'), ...
              handles.compensationPerKwhSoldToBattery.get('String'), ...
              handles.durationOfSimulation.get('String'));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% End custom code