function varargout = neighbourhood_out(varargin)
% NEIGHBOURHOOD_OUT MATLAB code for neighbourhood_out.fig
%      NEIGHBOURHOOD_OUT, by itself, creates a new NEIGHBOURHOOD_OUT or raises the existing
%      singleton*.
%
%      H = NEIGHBOURHOOD_OUT returns the handle to a new NEIGHBOURHOOD_OUT or the handle to
%      the existing singleton*.
%
%      NEIGHBOURHOOD_OUT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NEIGHBOURHOOD_OUT.M with the given input arguments.
%
%      NEIGHBOURHOOD_OUT('Property','Value',...) creates a new NEIGHBOURHOOD_OUT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before neighbourhood_out_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to neighbourhood_out_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help neighbourhood_out

% Last Modified by GUIDE v2.5 21-Jan-2016 15:04:09

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @neighbourhood_out_OpeningFcn, ...
                   'gui_OutputFcn',  @neighbourhood_out_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before neighbourhood_out is made visible.
function neighbourhood_out_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to neighbourhood_out (see VARARGIN)

% Choose default command line output for neighbourhood_out
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% This sets up the initial plot - only do when we are invisible
% so window can get raised using neighbourhood_out.

outputs = evalin('base','who');

% Inadvertently kills battery graph!
%outputs = outputs(strncmpi(outputs(:,1), 'House', 5), :);

% Only kill tout. Hack due to time constraints!!
% Really ought to be handled better in future versions (see README
% for more in-depth explanation).
outputs(numel(outputs),:) = [];

handles.popupmenu1.set('String', outputs);

if strcmp(get(hObject,'Visible'),'off') %TODO
    pushbutton1_Callback(hObject, eventdata, handles);
end

% UIWAIT makes neighbourhood_out wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = neighbourhood_out_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axes1);
cla;

str = getCurrentPopupString(handles.popupmenu1);
var = evalin('base', str);        

% MinX is allways 0
maxX = max(var.Time);

minY = min(min(var.Data));
maxY = max(max(var.Data));

% Create a Zero line
x = linspace(0, maxX);
zeroLine = x * 0;

plot(var, x, zeroLine, 'k'); % The 'k' means "black"

xLabels = {};

for i = 1 : (12 * 365) :(maxX+1)
        
    if(mod((i-1), (24 * 365)) == 0)
        xLabels{numel(xLabels) + 1} = numel(xLabels) / 2;
    else
        xLabels{numel(xLabels) + 1} = '';
    end
    
end

% Set up X-Axis
handles.axes1.set('XTick', 0:(12 * 365):maxX);
handles.axes1.set('XTickLabel', xLabels);
handles.axes1.set('XLim', [0 maxX]);
xlabel('Time in Years');

% Set up Y-Axis
%handles.axes1.set('YTick', minY:10000:maxY);
%handles.axes1.set('YTickLabel', minY:10000:maxY);
%handles.axes1.set('YLim', [minY maxY]);

% Draw arrows on axis
axp = handles.axes1.get('Position');
%handles.axes1.set('ActivePositionProperty','outerposition');

xs = axp(1); xe = axp(1) + axp(3) + 0.025;
ys = axp(2); ye = axp(2) + axp(4) + 0.04;

annotation('arrow', [xs xe], [ys ys]);
annotation('arrow', [xs xs], [ys ye]);

if (strendswith(str, 'gradient'))
    ylabel('kWh');
    legend('Greedy','Smart', 'Without Microgrid Controller');

elseif (strendswith(str, 'split_amortisation'))
    ylabel('Euro');
    legend('Without Microgrid Controller','Greedy', 'Smart');

elseif(strendswith(str, 'merged_amortisation'))
    ylabel('Euro');
    legend('Greedy','Smart');

elseif(strendswith(str, 'over_time'))
    ylabel('kWh');
    legend('Greedy','Smart');
    
end

% Better visualsation
grid on; grid minor;
title('');

%set(handles.figure1, 'WindowButtonMotionFcn', @(hobject, eventdata) mouse_hover(hobject, eventdata, handles));

% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)

% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Cf. https://stackoverflow.com/questions/1904972/how-do-i-make-an-empty-anonymous-function-in-matlab
disp('');

function str = getCurrentPopupString(hh)
%# getCurrentPopupString returns the currently selected string in the popupmenu with handle hh

%# could test input here
if ~ishandle(hh) || strcmp(get(hh,'Type'),'popupmenu')
error('getCurrentPopupString needs a handle to a popupmenu as input')
end

%# get the string - do it the readable way
list = get(hh,'String');
val = get(hh,'Value');
if iscell(list)
   str = list{val};
else
   str = list(val,:);
end

function mouse_hover(hObject, eventdata, handles)

delete(findall(gcf,'Tag','mousePos'))
pos = get(gca, 'CurrentPoint');

axisX = handles.axes1.get('xlim');
axisY = handles.axes1.get('ylim');

minX = axisX(1);
maxX = axisX(2);

minY = axisY(1);
maxY = axisY(2);

mX = pos(1,1);
mY = pos(1,2);

if mX > minX && mX < maxX && mY > minY && mY < maxY
    
    x = [minX maxX];
    y = [0.1 0.9];
    
    regX = polyfit(x, y, 1);
    
    x = [minY maxY];
    y = [0.13 0.8];
    
    regY = polyfit(x, y, 1);
    fx = 5*sin(0.05*mX);
    
    pointX = regX(1) * mX + regX(2);
    pointY = regY(1) * fx + regY(2);
        
    dim = [pointX pointY .0 .0];
    dimPoint = [pointX pointY 0.01 0.01];
    str = [num2str(mX / 12) ' | ' num2str(fx)];
    
    annotation('ellipse', dimPoint, 'FaceColor', 'blue', 'Tag', 'mousePos');
    annotation('textbox', dim, 'String', str, 'FitBoxToText', 'on', 'Tag', 'mousePos');

end

function b = strendswith(s, pat)

sl = length(s);
pl = length(pat);

b = (sl >= pl && strcmp(s(sl-pl+1:sl), pat)) || isempty(pat);
